'==========================================================================
'
'        WOOD BURNING SIMULATOR DYNAMIC ANALYSIS PROGRAM
'        BY SCANADA CONSULTANTS LIMITED        VERSION 5.0   12/89
'
'==========================================================================
'        DEVELOPED BY: SCANADA CONSULTANTS LIMITED
'        FOR CANADA MORTGAGE & HOUSING CORPORATION
'        PROGRAM DESIGN & CODING: MICHAEL C. SWINTON
'                                 MICHAEL D. MONETTE
'                                 ROBIN P. SINHA
'                                 ANIL J. PAREKH
'                                 J.R. YVES LEMOINE
'                                 OCTOBER 1984  - DECEMBER 1989
'        FLUEPIPE REVISIONS-MAY 15, 1986 BY R.P. SUMI
'==========================================================================
'
DECLARE SUB ScreenHandler ()
DECLARE SUB CopySpcFile ()
DECLARE SUB ReadSpcFile ()
DECLARE SUB Menu1 ()
DECLARE SUB Menu2 ()
DECLARE SUB ReadFile ()
DECLARE SUB WriteFile ()
DECLARE SUB InputFiles ()
DECLARE SUB FCount (X$, X%)
DECLARE SUB BasDir (BYVAL X%)
  
REM $INCLUDE: 'WOODCOM5.BAS'
REM $INCLUDE: 'WOODINCM.BAS'
'
    GOSUB 4000 ' MAIN PROGRAM
600 CLOSE : COLOR 7, 0: CLS : END
1000 REM *** INITIALIZE ***
     ON ERROR GOTO 29000
     SHC$ = "INI,1," + LIBT$ + ".SLB": CALL ScreenHandler: IF S.ERR% THEN PRINT "SCREEN HANDLER ERROR WHILE OPENING LIBRARY": STOP
     SHC$ = "ELC/EFK,2": CALL ScreenHandler' ENABLE LOWER CASE AND FUNCTION KEY 2
     RETURN
2000 REM *** PROCESS MAIN SCREEN ***
     SHC$ = "DIS," + SCRTL$ + "/CIF": CALL ScreenHandler
     GOSUB 3000 ' SET DEFAULTS
     SHC$ = "DIF": CALL ScreenHandler ' DISPLAY FIELD VALUES AND DEFAULTS
2050 SHC$ = "EFK,3/INP/DFK,3": CALL ScreenHandler
     IF S.RC% = 2 THEN 2990
     IF S.RC% = 3 THEN SHC$ = "MSG,FUNCTION KEY 3 PRESSED": CALL ScreenHandler: GOTO 2050
     'SHC$="MGV,PROCESS COMPLETED. PRESS ANY KEY FOR ANOTHER SCREEN": call ScreenHandler
     COLOR 7, 0
2990 RETURN
3000 REM *** SET NUMERIC FIELDS ON SCREEN ***
     FOR S.F% = 1 TO NF%
     IF VAR(S.F%) < -999 THEN GOTO 3020
     'S.VAL#=VAR(S.F%): GOSUB 55300: SI.DF$(S.F%)=SI.DATA$(S.F%): GOTO 3080
     X$ = STR$(FNC#(VAR(S.F%), SI.DP%(S.F%))): GOSUB 3500: LSET SI.DATA$(S.F%) = X$: SI.DF$(S.F%) = SI.DATA$(S.F%): GOTO 3080
3020 LSET SI.DATA$(S.F%) = VA$(S.F%): SI.DF$(S.F%) = SI.DATA$(S.F%)
3080 NEXT
     RETURN
3500 REM *** CONVERT NUMBER ***
     X% = INSTR(X$, "."): IF X% = 0 THEN X$ = X$ + ".": X% = LEN(X$)
     IF SI.DP%(S.F%) > 6 THEN SI.DP%(S.F%) = 5
     X$ = LEFT$(X$ + STRING$(SI.DP%(S.F%), "0"), X% + SI.DP%(S.F%))
     IF LEFT$(X$, 1) = " " THEN X$ = MID$(X$, 2)
     RETURN
     '
4000 '   MAIN INPUT PROGRAM
     '
     ON ERROR GOTO 29000
     IF MASTER% = 1234 THEN GOTO 4280
     FTP$(1) = "F": FTP$(2) = "F": FTP$(3) = "W": FTP$(4) = "W"
     SCRFT$(1) = "FPLINT": SCRFT$(2) = "FPLEXT": SCRFT$(3) = "WSTINT": SCRFT$(4) = "WSTEXT"
     SCRFT1$(1) = "FPLACE": SCRFT1$(2) = "FPLACE": SCRFT1$(3) = "WSTOVE": SCRFT1$(4) = "WSTOVE"
     SCRCT$(1) = "CHIM#2": SCRCT$(2) = "CHIM#3": SCRCT$(3) = "CHIM#5"
     OPEN "WINSTAL5.DAT" FOR INPUT AS #3
     INPUT #3, IGRAPH%, DRIVE$, IOUT%, INDRIVE$
     CLOSE #3
     Z$ = "N": FLUEIN$ = "WOODIN5"
     IF SCSFLAG% = 0 THEN FL1% = 2 - IGRAPH%: FL2% = 0: TMP1% = 1: TMP2% = 2: TMP3% = 3: TMP4% = 4
     CTYP$(1) = "UNLINED MASONRY": CTYP$(2) = "A-VENT": CTYP$(3) = "LINED MASONRY"
     TLFLAG% = 0: PCODE% = 1: KEY OFF: ENTRY% = 0: WIDTH "lpt1:", 233
     ' PROPERTIES OF AIR
     HCONV = 1 / .03: SBCONST = 5.669E-08: TARING = 0: TBSURF = 0
      PRFLAG% = 0
     '
4280  REM : INTIALIZATION OF VARIABLES
     FOR AA% = 1 TO 9: CHM$(AA%) = " ": NEXT AA%
     LIBT$ = "WOOD-G5": GOSUB 1000
     IF MASTER% = 1234 THEN GOTO 4380
     SCRTL$ = "WELCOM"
     NF% = 1
     FOR I% = 1 TO NF%: VAR(I%) = -1000: NEXT
     VA$(1) = " "
     GOSUB 2000
     GOTO 4530
4380 REM:
4390 CALL Menu1
     COLOR 15, 0: PRINT : INPUT "YOUR SELECTION (NUMBER FROM 1 TO 7) --> "; SS$: COLOR 7: IF VAL(SS$) < 1 OR VAL(SS$) > 8 THEN GOTO 4390
     SS = VAL(SS$)
     ON SS GOTO 5000, 8900, 9030, 4750, 5170, 4530, 5920
4530 REM: LOAD FILE ROUTINE
     ENTRY% = 1
CALL InputFiles
     CHK$ = ".": LOCDOT = INSTR(DefaultFile$, CHK$): FAULT$ = LEFT$(DefaultFile$, LOCDOT - 1)
     IF IOUT% = 2 OR IGRAPH% = 1 THEN OU$ = DRIVE$ + FAULT$ + ".PRN" ELSE OU$ = "LPT1:"
     PW$ = DRIVE$ + FAULT$ + ".PR2"
    
     CALL ReadFile
     CLOSE #2
     COLOR 7
     GOSUB 17000    'READ THE SPEC FILE FOR INITIALIZATION OF VARIABLES
     FOR AA% = 1 TO 9: CHM$(AA%) = " ": NEXT AA%
     GOTO 4390
4750 REM: SAVE FILE ROUTINE
4760 HDR$ = "INPUT FILE SAVE ROUTINE": QN1$ = "ENTER THE NAME OF THE DISK FILE TO STORE THIS SET UP DATA": TFLAG = 1: TLEN = 8: QN2$ = "(EXTENSION '.WD5' IS AUTOMATICALLY ADDED)"
     FAULT$ = UCASE$(DefaultFile$): CHK$ = ".": LOCDOT = INSTR(DefaultFile$, CHK$): FAULT$ = LEFT$(DefaultFile$, LOCDOT - 1)
     GOSUB 10240
    
     IF LEN(NFAULT$) > 8 THEN LOCATE 20, 10: INPUT "THE FILENAME IS TOO LONG.  PRESS ENTER TO CONTINUE  ", ANS$: GOTO 4760

4790 DefaultFile$ = UCASE$(NFAULT$) + ".WD5": PW$ = DRIVE$ + UCASE$(NFAULT$) + ".PR2": XIST% = 0
     IF IOUT% = 2 OR IGRAPH% = 1 THEN OU$ = DRIVE$ + NFAULT$ + ".PRN" ELSE OU$ = "LPT1:"

        FileSpec$ = INDRIVE$ + "*.WD5"
        FCount FileSpec$, COUNT%                 'returns number of matching files
        FOR X% = 1 TO COUNT% + 1                 'reserve room for each name
        FileName$(X%) = SPACE$(12)
        NEXT
        FileName$(0) = FileSpec$                'tell BasDir which files to get
        BasDir VARPTR(FileName$(0))
    
     FOR AA% = 1 TO COUNT%
     IF UCASE$(DefaultFile$) = UCASE$(MID$(FileName$(AA%), 1, LEN(DefaultFile$))) THEN XIST% = 1
     NEXT AA%
     IF XIST% = 1 THEN LOCATE 20, 10: INPUT "THE FILE EXISTS.  DO YOU WANT TO REPLACE IT? (Y/N)  ", ANS$ ELSE GOTO 4795
     IF UCASE$(ANS$) <> "Y" THEN GOTO 4760

4795 CHK$ = " ": LOCDOT = INSTR(SPCFILE$, CHK$): IF LOCDOT = 0 THEN CHK$ = ".": LOCDOT = INSTR(SPCFILE$, CHK$)
     OLDSPC$ = UCASE$(LEFT$(SPCFILE$, LOCDOT - 1))
     IF OLDSPC$ = UCASE$(NFAULT$) THEN GOTO 4800 ELSE OLDSPC$ = UCASE$(SPCFILE$)
     SPCFILE$ = UCASE$(NFAULT$) + ".SPC"
     GOSUB 17700

4800 QN1$ = "ENTER THE DESCRIPTIVE CASE IDENTIFICATION TITLE USED AS THE CASE IDENTIFIER": QN2$ = "(INPUT A NAME SUCH AS-> GAS FURNACE/15 KW/EXTERIOR FLUE/OCT 85)": FAULT$ = TITLE$: TFLAG = 1: TLEN = 30: GOSUB 10240
     TITLE$ = NFAULT$
     CALL WriteFile'
     GOTO 4390
5000 REM: CHANGE FILE DATA ROUTINE
     IF FB$ = "W" THEN IF XPT < (CHBOT - 1) THEN FCTYPE = 3 ELSE FCTYPE = 4
     IF FB$ = "F" THEN IF XPT < (CHBOT - 1) THEN FCTYPE = 1 ELSE FCTYPE = 2
5010 CALL Menu2
     FOR AA% = 1 TO 9: LOCATE 4 + AA%, 2: PRINT CHM$(AA%): NEXT AA%
     LOCATE 23, 5: PRINT "(An * Marks Items that have been changed since file was loaded)": LOCATE 14, 10
     PRINT : COLOR 15, 0: PRINT : INPUT "YOUR SELECTION  (NUMBER FROM 1 TO 9) --> "; SS$: COLOR 7
     IF VAL(SS$) < 1 OR VAL(SS$) > 9 THEN GOTO 5010
     SS = VAL(SS$)
     ON SS GOTO 5930, 6190, 6500, 7830, 8420, 11000, 12000, 15000, 4390
5170 REM: CHAIN INTO WOODSIM AND RUN PROGRAM
      HDR$ = "RUN IDENTIFIER": QN1$ = "ENTER THE RUN IDENTIFICATION": QN2$ = "(Omit the FUEL TYPE and DATE as these are automatically printed)": FAULT$ = TITLE$: TFLAG = 1: TLEN = 30: GOSUB 10240
      TITLE$ = NFAULT$
     PRFLAG% = 1
     COLOR 19: LOCATE 20, 50: PRINT "***   Please Standby ***": COLOR 7
     GOSUB 30050   'ASSIGN FIREPLACE PROPERTIES
     CHAIN "WOODSIM5"
5920 CLS : PRINT : PRINT : PRINT "PROGRAM COMPLETED": END
5930 REM: CHOICE OF FUEL TYPE / FLUE LOCATION & SPECS OF VERTICAL DIMENSIONS
     CHM$(1) = "*"
     SCRTL$ = "TYPLOC"
     NF% = 1
     FOR I% = 1 TO NF%: VAR(I%) = -1000: NEXT
     '
     IF FB$ = "W" THEN IF XPT < (CHBOT - 1) THEN VAR(1) = 3 ELSE VAR(1) = 4
     IF FB$ = "F" THEN IF XPT < (CHBOT - 1) THEN VAR(1) = 1 ELSE VAR(1) = 2
     GOSUB 2000
     FCTYPE = VAL(SI.DATA$(1))
     IF FCTYPE = 2 * INT(FCTYPE / 2) THEN CHIMT$ = "E" ELSE CHIMT$ = "I"
     FB$ = FTP$(FCTYPE)
     SCRTL$ = SCRFT$(FCTYPE)
     NF% = 5
     TROB1 = CHBOT: TROB2 = HT(4)
     '
     VAR(1) = LHC
     VAR(2) = CHBOT
     VAR(3) = HT(4)
     IF FB$ = "W" THEN VAR(4) = HT(14) ELSE VAR(4) = HT(6)
     IF FB$ = "W" THEN VAR(5) = TFPLN ELSE VAR(5) = HT(14)
     GOSUB 2000
     LHC = VAL(SI.DATA$(1))
     CHBOT = VAL(SI.DATA$(2))
     HT(4) = VAL(SI.DATA$(3))
     IF FB$ = "W" THEN HT(14) = VAL(SI.DATA$(4)) ELSE HT(6) = VAL(SI.DATA$(4))
     IF FB$ = "W" THEN TFPLN = VAL(SI.DATA$(5)) ELSE HT(14) = VAL(SI.DATA$(5))
     IF FB$ = "W" THEN HT(6) = HT(4): HT(17) = HT(4)
     IF FB$ = "F" THEN TFPLN = HT(4) - CHBOT: HT(17) = HT(4): RISET = HT(4) - CHBOT: RISE(1) = RISET / 2: RISE(2) = RISE(1)
     IF FB$ = "W" AND TROB1 <> CHBOT OR TROB2 <> HT(4) THEN FPFLAG = 0
     IF FCTYPE = 1 OR FCTYPE = 3 THEN XPT = LHC ELSE XPT = CHBOT
     HT(15) = HT(14): HT(16) = HT(14)
     HT(8) = LNPP: HT(9) = LNPP
     HT(18) = HT(17)
     HT(10) = HT(6): HT(11) = HT(6): HT(12) = HT(6): HT(13) = HT(6): HT(19) = HT(6)
     HT(5) = HT(4)
     GOTO 5010
6190 REM      WOOD STOVE / FIREPLACE CHARACTERISTICS
     CHM$(2) = "*"
     SCRTL$ = SCRFT1$(FCTYPE)
     NF% = 10
     FOR I% = 1 TO NF%: VAR(I%) = -1000: NEXT
     VAR(1) = AR(15)
     VAR(2) = AR(18)
     VAR(3) = AR(11)
     VAR(4) = FICV
     VAR(5) = ROWSOFT
     VAR(6) = HEATSOFT / 1000
     VAR(7) = HCSOFT / 1000
     VAR(8) = ROWHARD
     VAR(9) = HEATHARD / 1000
     VAR(10) = HCHARD / 1000
     GOSUB 2000
     AR(15) = VAL(SI.DATA$(1))
     AR(18) = VAL(SI.DATA$(2))
     AR(11) = VAL(SI.DATA$(3))
     APRD = 100!
     FICV = VAL(SI.DATA$(4))
     ROWSOFT = VAL(SI.DATA$(5))
     HEATSOFT = VAL(SI.DATA$(6)) * 1000
     HCSOFT = VAL(SI.DATA$(7)) * 1000
     ROWHARD = VAL(SI.DATA$(8))
     HEATHARD = VAL(SI.DATA$(9)) * 1000
     HCHARD = VAL(SI.DATA$(10)) * 1000
     IF FB$ = "F" THEN GOSUB 18000
     IF FB$ = "W" THEN GOSUB 19000
     AR(5) = AR(18): AR(2) = AR(18)
     GOTO 5010
6500 REM: INPUT OF FLUE PIPE DIMENSIONS
     IF FB$ = "F" THEN INPUT "A FIREPLACE HAS NO FLUEPIPE.  PRESS ENTER TO CONTINUE.", ANS$: GOTO 5010
6510 STRTOVR$ = "N"
     RISEMAX = ABS(CHBOT - HT(5)): RISET = 0: FPLNT = 0
     CHM$(3) = "*"
     HDR$ = "FLUE PIPE CHARACTERISITCS"
     QN1$ = "TOTAL NUMBER OF STRAIGHT SECTIONS FROM TOP OF DILUTION DEVICE TO CHIMNEY BOTTOM": QN2$ = "INPUT NUMBER OF SEGMENTS"
6565 FAULT = NFPSEGS%: GOSUB 10240: IF NFAULT < 1 OR NFAULT > 4 THEN GOSUB 10690: GOTO 6565
     NFPSEGS% = NFAULT
     IF NFAULT <> FAULT THEN FPFLAG = 0: REM DEFAULT INPUT IS CHANGED
6600 '
     FPLNMAX = TFPLN: REM TFPLN = NFAULT
     QN1$ = "HOW MANY  45 deg. ELBOWS IN THE FLUE PIPE OR VENT CONNECTOR"
6645 QN2$ = "(ENTER 2 FOR EACH 90 deg. ELBOW.  ADD 2.5 FOR A TEE SECTION%)": FAULT = NELBOWS%: GOSUB 10240: IF NFAULT < 0 OR NFAULT > 10 THEN GOSUB 10690: GOTO 6645
     NELBOWS% = NFAULT
     NEO% = NE%
     FOR FPSEG% = 1 TO NFPSEGS%
     ROR$ = "RISE"
     QN1$ = "SECTION% ": FPSEG$ = STR$(FPSEG%): QN1$ = QN1$ + FPSEG$: QN2$ = "INPUT THE " + ROR$ + " OF THIS SECTION%(in m)"
     IF FPFLAG = 0 THEN GOTO 6775 ELSE FAULT = RISE(FPSEG%): GOTO 6780
6775 FAULT = ABS((RISEMAX - RISET) / ((NFPSEGS% - FPSEG% + 1)))
6780 GOSUB 10240: IF NFAULT < 0 THEN GOSUB 10690: GOTO 6780
     IF (NFAULT - (RISEMAX - RISET)) > .1 THEN GOSUB 10715: IF STRTOVR$ = "Y" THEN GOTO 6510 ELSE GOTO 6780
     IF FPSEG% = NFPSEGS% AND ABS(RISEMAX - (RISET + NFAULT)) > .1 THEN GOSUB 10715: IF STRTOVR$ = "Y" THEN GOTO 6510 ELSE GOTO 6780
     RISE(FPSEG%) = NFAULT: IF NFAULT <> FAULT THEN FPFLAG = 0
     REM:IF NFAULT<>FAULT THEN FPFLAG=0
     RISET = RISET + RISE(FPSEG%)
     ROR$ = "LENGTH": QN1$ = QN1$
     IF FPFLAG = 0 THEN GOTO 6845 ELSE FAULT = FPLN(FPSEG%): GOTO 6850
6845 FAULT = ((FPLNMAX - FPLNT) / ((NFPSEGS% - FPSEG%) + 1))
6850 GOSUB 10240: IF NFAULT < 0 THEN GOSUB 10690: GOTO 6860
6860 IF (NFAULT - (FPLNMAX - FPLNT)) > .1 THEN GOSUB 10715: IF STRTOVR$ = "Y" THEN GOTO 6510 ELSE GOTO 6850
     IF FPSEG% = NFPSEGS% AND ABS(FPLNMAX - (FPLNT + NFAULT)) > .1 THEN GOSUB 10715: IF STRTOVR$ = "Y" THEN GOTO 6510 ELSE GOTO 6850
     IF ABS(RISET - RISEMAX) < .1 AND ABS((FPLNT + NFAULT) - FPLNMAX) < .1 AND FPSEG% < NFPSEGS% THEN GOSUB 10725: IF STRTOVR$ = "Y" THEN GOTO 6510 ELSE GOTO 6850: REM:IF FLUEPIPE FITS AND ELBOWS STILL NOT USED UP SIGNAL ERROR
     FPLN(FPSEG%) = NFAULT: IF NFAULT <> FAULT THEN FPFLAG = 0
     FPLNT = FPLNT + FPLN(FPSEG%)
     NEXT FPSEG%
     FPFLAG = 1
     SCRTL$ = "FPIPE1"
     NF% = 16
     VAR(1) = AR(5)
     VAR(2) = FPDI2(2)
     VAR(3) = FPDI2(3)
     VAR(4) = FPDI2(4)
     VAR(5) = FPELTL
     VAR(6) = FPELTS
     VAR(7) = FPELTO
     VAR(8) = FPDENL
     VAR(9) = FPDENS
     VAR(10) = FPDENO
     VAR(11) = FPHC(2)
     VAR(12) = FPHC(3)
     VAR(13) = FPHC(4)
     VAR(14) = 1! / (FPELTL * FPTHCL)
     IF FPTHCS = 0 THEN VAR(15) = 0 ELSE VAR(15) = 1! / (FPELTS * FPTHCS)
     IF FPTHCO = 0 THEN VAR(16) = 0 ELSE VAR(16) = 1! / (FPELTO * FPTHCO)
  GOSUB 2000
     AR(5) = VAL(SI.DATA$(1))
     FPDI2(2) = VAL(SI.DATA$(2))
     FPDI2(3) = VAL(SI.DATA$(3))
     FPDI2(4) = VAL(SI.DATA$(4))
     FPELTL = VAL(SI.DATA$(5))
     FPELTS = VAL(SI.DATA$(6))
     FPELTO = VAL(SI.DATA$(7))
     FPDENL = VAL(SI.DATA$(8))
     FPDENS = VAL(SI.DATA$(9))
     FPDENO = VAL(SI.DATA$(10))
     FPHC(2) = VAL(SI.DATA$(11))
     FPHC(3) = VAL(SI.DATA$(12))
     FPHC(4) = VAL(SI.DATA$(13))
     FPTHCL = 1! / (VAL(SI.DATA$(14)) * FPELTL)
     IF VAL(SI.DATA$(15)) = 0 THEN FPTHCS = 0 ELSE FPTHCS = 1! / (VAL(SI.DATA$(15)) * FPELTS)
     IF VAL(SI.DATA$(16)) = 0 THEN FPTHCO = 0 ELSE FPTHCO = 1! / (VAL(SI.DATA$(16)) * FPELTO)
     AR(4) = AR(5): AR(2) = AR(5): AR(18) = AR(5)
     FOR ZZ% = 1 TO NFPSEGS%
     DI2(2, ZZ%) = FPDI2(2): HC(2, ZZ%) = FPHC(2)
     DI2(3, ZZ%) = FPDI2(3): HC(3, ZZ%) = FPHC(3)
     DI2(4, ZZ%) = FPDI2(4): HC(4, ZZ%) = FPHC(4)
     ELTL(ZZ%) = FPELTL: ELTS(ZZ%) = FPELTS: ELTO(ZZ%) = FPELTO
     DENL(ZZ%) = FPDENL: DENS(ZZ%) = FPDENS: DENO(ZZ%) = FPDENO
     THCL(ZZ%) = FPTHCL: THCS(ZZ%) = FPTHCS: THCO(ZZ%) = FPTHCO
     NEXT ZZ%
     IF NE% <> NEO% THEN GOTO 8310
     GOTO 5010
7830 REM: INPUT OF CHIMNEY CHARACTERISTICS
     SCSFLAG% = 0
     CHM$(4) = "*"
     SCRTL$ = "CHIM#1"
     NF% = 1: VAR(1) = ICHTYPE%
     GOSUB 2000
     IF ICHTYPE% = VAL(SI.DATA$(1)) THEN GOTO 7900
     CLS : LOCATE 6, 1: PRINT "The graphic on the following screen has been changed"
     PRINT "to show a(n) "; CTYP$(VAL(SI.DATA$(1))); " chimney"
     LOCATE 9, 1: PRINT "However the numerical entries have NOT been changed -  ": LOCATE 11, 1: PRINT "they are the values in the file you loaded."
     LOCATE 13, 1: PRINT "You can change them now or start again with a file ";
     LOCATE 15, 1: PRINT "which includes a(n) "; CTYP$(VAL(SI.DATA$(1))); " chimney"
     LOCATE 18, 1: INPUT "Your choice: Change or Start again - [C]/S?  ", ANS$
     IF ANS$ = "S" OR ANS$ = "s" THEN GOTO 4390
     ICHTYPE% = VAL(SI.DATA$(1))
7900 SCRTL$ = SCRCT$(ICHTYPE%)
     NF% = 16
     VAR(1) = AR(2)
     VAR(2) = CHDI2(2)
     VAR(3) = CHDI2(3)
     VAR(4) = CHDI2(4)
     VAR(5) = CHELTL
     VAR(6) = CHELTS
     VAR(7) = CHELTO
     VAR(8) = CHDENL
     VAR(9) = CHDENS
     VAR(10) = CHDENO
     VAR(11) = CHHC(2)
     VAR(12) = CHHC(3)
     VAR(13) = CHHC(4)
     VAR(14) = 1! / (CHELTL * CHTHCL)
     VAR(15) = 1! / (CHELTS * CHTHCS)
     VAR(16) = 1! / (CHELTO * CHTHCO)
     GOSUB 2000
     AR(2) = VAL(SI.DATA$(1))
     CHDI2(2) = VAL(SI.DATA$(2))
     CHDI2(3) = VAL(SI.DATA$(3))
     CHDI2(4) = VAL(SI.DATA$(4))
     CHELTL = VAL(SI.DATA$(5))
     CHELTS = VAL(SI.DATA$(6))
     CHELTO = VAL(SI.DATA$(7))
     CHDENL = VAL(SI.DATA$(8))
     CHDENS = VAL(SI.DATA$(9))
     CHDENO = VAL(SI.DATA$(10))
     CHHC(2) = VAL(SI.DATA$(11))
     CHHC(3) = VAL(SI.DATA$(12))
     CHHC(4) = VAL(SI.DATA$(13))
     CHTHCL = 1! / (VAL(SI.DATA$(14)) * CHELTL)
     CHTHCS = 1! / (VAL(SI.DATA$(15)) * CHELTS)
     CHTHCO = 1! / (VAL(SI.DATA$(16)) * CHELTO)
     AR(3) = AR(2): AR(5) = AR(2): AR(18) = AR(2)
     IF FB$ = "F" THEN GOSUB 14000
8310 FOR ZZ% = NFPSEGS% + 1 TO NE%
     DI2(2, ZZ%) = CHDI2(2): HC(2, ZZ%) = CHHC(2)
     DI2(3, ZZ%) = CHDI2(3): HC(3, ZZ%) = CHHC(3)
     DI2(4, ZZ%) = CHDI2(4): HC(4, ZZ%) = CHHC(4)
     ELTL(ZZ%) = CHELTL: ELTS(ZZ%) = CHELTS: ELTO(ZZ%) = CHELTO
     DENL(ZZ%) = CHDENL: DENS(ZZ%) = CHDENS: DENO(ZZ%) = CHDENO
     THCL(ZZ%) = CHTHCL: THCS(ZZ%) = CHTHCS: THCO(ZZ%) = CHTHCO
     NEXT ZZ%
     IF NE% <> NEO% THEN GOTO 8860
     GOTO 5010
8420 '
     CHM$(5) = "*"
     SCSFLAG% = 0
     SCRTL$ = "GENRL1"
     NF% = 14
     VAR(1) = C
     VAR(2) = N
     VAR(3) = QF
     VAR(4) = FP
     VAR(5) = T1
     VAR(6) = T9
     VAR(7) = VWINDH
     VAR(8) = VWINDV
NMID% = INT(NE% / 2)
     VAR(9) = TI(1, NMID%)
     VAR(10) = TI(2, NMID%)
     VAR(11) = TI(3, NMID%)
     VAR(12) = TI(4, NMID%)
     VAR(13) = TMF
     VAR(14) = T7F
     GOSUB 2000
     C = VAL(SI.DATA$(1))
     N = VAL(SI.DATA$(2))
     QF = VAL(SI.DATA$(3))
     FP = VAL(SI.DATA$(4))
     T1 = VAL(SI.DATA$(5))
     T9 = VAL(SI.DATA$(6))
     VWINDH = VAL(SI.DATA$(7))
     VWINDV = VAL(SI.DATA$(8))
     TI(1, NMID%) = VAL(SI.DATA$(9))
     TI(2, NMID%) = VAL(SI.DATA$(10))
     TI(3, NMID%) = VAL(SI.DATA$(11))
     TI(4, NMID%) = VAL(SI.DATA$(12))
     TMF = VAL(SI.DATA$(13))
     T7F = VAL(SI.DATA$(14))
     VWINDT = SQR(VWINDH ^ 2 + VWINDV ^ 2)
     IF VWINDH = 0! AND VWINDV < 0! THEN THETAW = -90!: GOTO 8860
     IF VWINDH = 0! AND VWINDV > 0! THEN THETAW = 90!: GOTO 8860
     IF VWINDH = 0! AND VWINDV = 0! THEN THETAW = 0! ELSE THETAW = 180! * ATN(VWINDV / VWINDH) / 3.141593
8860 FOR AA% = 2 TO NE%: TI(1, AA%) = TI(1, NMID%): TI(2, AA%) = TI(2, NMID%): TI(3, AA%) = TI(3, NMID%): TI(4, AA%) = TI(4, NMID%): NEXT AA%
     T6F = T7F
     TN(1) = T1: TN(2) = TI(1, 1): TN(3) = TN(2): TN(4) = TN(2): TN(5) = TN(2): TN(6) = (T6F + T9) / 2: TN(7) = T1: TN(8) = T1: TN(9) = T9: TN(10) = T9: TN(11) = T9: TN(12) = TN(6): TN(13) = T9: TN(14) = T9: TN(15) = T9: TN(16) = T6F: TN(17) = T6F: _
                                        TN(18) = T6F: TN(19) = TN(6)
     GOTO 5010
8900 REM: RUN TIME CONTROLS
     SCRTL$ = "GENRL2"
     NF% = 7
     VAR(1) = SCS
     VAR(2) = SEC
     VAR(3) = FS
     VAR(4) = CDT
     VAR(5) = EXFAN.ON
     VAR(6) = EXFAN.OFF
     VAR(7) = ST
     GOSUB 2000
     SCS = VAL(SI.DATA$(1))
     SEC = VAL(SI.DATA$(2))
     FS = VAL(SI.DATA$(3))
     CDT = VAL(SI.DATA$(4))
     ST = VAL(SI.DATA$(7))
     EXFAN.ON = VAL(SI.DATA$(5))
     EXFAN.OFF = VAL(SI.DATA$(6))
     GOTO 4390
9030 REM: OUTPUT FORMAT MENU
     CLS : SCREEN 0: KEY OFF
9060 TLEN = 1: TFLAG = 1: QN1$ = "DO YOU WANT YOUR OUTPUTS ON A GRAPH (G) OR IN TABLES (T)": HDR$ = "PRINT CONTROLS": QN2$ = "(ENTER EITHER  G  OR  T)": FAULT$ = GD$: GOSUB 10240
     GD$ = NFAULT$
     IF GD$ = "G" OR GD$ = "g" THEN GD$ = "G": GOTO 9170
     IF GD$ = "T" OR GD$ = "t" THEN GD$ = "T": OU$ = "LPT1:": GOTO 9100
     GOSUB 10690: GOTO 9060
9100 TLEN = 1: TFLAG = 1: QN1$ = "Do you want a DETAILED summary or a PRESSURE PARAMETER summary ": HDR$ = "PRINT CONTROLS": QN2$ = "(ENTER EITHER  D  OR  P)": FAULT$ = P$: GOSUB 10240
     P$ = NFAULT$
     IF P$ = "p" THEN P$ = "P"
     IF P$ = "d" THEN P$ = "D"
     IF P$ = "P" OR P$ = "D" THEN GOTO 9120 ELSE GOSUB 10690: GOTO 9100
9120 QN1$ = "INTERVAL BETWEEN PRINTER OUTPUTS": QN2$ = "(In Seconds: e.g. 10 seconds)": FAULT = Z2: GOSUB 10240: IF NFAULT < 0 OR NFAULT > 1000 THEN GOSUB 10690: GOTO 9120
     Z2 = NFAULT
     IF IOUT% = 1 THEN FAULT$ = "P" ELSE FAULT$ = "D"
9140 TFLAG = 1: TLEN = 1: QN1$ = "DO YOU WANT THE OUTPUTS ON THE PRINTER (P)  OR  ON DISK  (D)": HDR$ = "PRINT CONTROLS": QN2$ = "(ENTER EITHER  P  OR  D)": GOSUB 10240
     IF NFAULT$ = "D" OR NFAULT$ = "d" OR NFAULT$ = "P" OR NFAULT$ = "p" THEN GOTO 9146 ELSE GOSUB 10690: GOTO 9140
9146 FAULT$ = DefaultFile$: CHK$ = ".": LOCDOT = INSTR(DefaultFile$, CHK$): FAULT$ = LEFT$(DefaultFile$, LOCDOT - 1)
     IF NFAULT$ = "D" OR NFAULT$ = "d" THEN TFLAG = 1: TLEN = 1: QN1$ = "ENTER THE NAME OF THE OUTPUT DISK FILE": QN2$ = "(the default drive and extension .PRN are added automatically)": GOSUB 10240: OU$ = DRIVE$ + NFAULT$ + ".PRN"
     FL1% = 0: GOTO 4390
9170 IF IGRAPH% = 1 THEN 9174
     CLS : LOCATE 5, 1: PRINT "YOUR SYSTEM APPARENTLY DOES NOT HAVE COMPATIBLE GRAPHICS CAPABILITY": PRINT "YOUR OUTPUTS WILL BE TABULAR INSTEAD"
     T = TIMER: WHILE TIMER < T + 5: WEND
     GD$ = "T": GOTO 9100
9174 FL1% = 1: CLS : SCREEN 0
     LOCATE 4, 20: PRINT "DO YOU WISH TO PLOT:"
     LOCATE 7, 20: PRINT "TEMPERATURE vs. TIME   (T)"
     LOCATE 9, 20: PRINT "PRESSURE vs. TIME      (P)"
     LOCATE 11, 20: PRINT "FLOW RATE vs. TIME     (F)"
     IF FL2% = 2 THEN FAULT$ = "F" ELSE IF FL2% = 1 THEN FAULT$ = "P" ELSE FAULT$ = "T"
     LOCATE 15, 20: PRINT "YOUR DEFAULT IS "; FAULT$; " ";
9265 LOCATE 17, 20: INPUT "T,P,F or ENTER(for default) "; ANS$
     IF ANS$ = "" THEN GOTO 9305
     IF ANS$ <> "T" AND ANS$ <> "P" AND ANS$ <> "F" AND ANS$ <> "t" AND ANS$ <> "p" AND ANS$ <> "f" THEN 9265
     IF ANS$ = "T" OR ANS$ = "t" THEN FL2% = 0
     IF ANS$ = "P" OR ANS$ = "p" THEN FL2% = 1
     IF ANS$ = "F" OR ANS$ = "f" THEN FL2% = 2
9305 ON FL2% GOTO 9660, 10030
     CLS
     TMTL$(1) = "YOU CAN PLOT  4  OF  6  TEMPERATURE VALUES vs. TIME"
     TMTL$(2) = "YOUR CHOICES ARE :"
     TMTL$(3) = "1 - FIREBOX EXHAUST GAS TEMP."
     TMTL$(4) = "2 - DILUTION MIXING TEMP."
     TMTL$(5) = "3 - MEAN CHIMNEYGAS TEMP."
     TMTL$(6) = "4 - CHIMNEY EXIT GAS TEMP."
     TMTL$(7) = "5 - MEAN CHIMNEY LINER TEMP."
     TMTL$(8) = "6 - FIREBOX WALL TEMPERATURE"
     TMTL$(9) = "YOUR DEFAULT VALUES ARE > "
     TMTL$(10) = "PRESS <ENTER> TO SELECT DEFAULT VALUES"
     TMTL$(11) = "OR C TO ENTER FOUR NEW OUTPUT VALUES"
     LOCATE 4, 15: PRINT TMTL$(1)
     LOCATE 6, 15: PRINT TMTL$(2)
     FOR X% = 1 TO 6
     LOCATE X% + 7, 20: PRINT TMTL$(X% + 2)
     NEXT X%
     LOCATE 15, 15: PRINT TMTL$(9); : PRINT USING " ##, ##, ##, and ##"; TMP1%, TMP2%, TMP3%, TMP4%
     FOR X% = 1 TO 2
     LOCATE 16 + X%, 15: PRINT TMTL$(9 + X%)
     NEXT X%
9510 LOCATE 20, 39: INPUT ANS$
     IF ANS$ = "" THEN TMP1% = 1: TMP2% = 2: TMP3% = 3: TMP4% = 4: GOTO 4390
     IF ANS$ = "C" OR ANS$ = "c" THEN 9550
     IF ANS$ <> "" OR ANS$ <> "C" OR ANS$ <> "c" THEN 9510
9550 FOR X% = 1 TO 7
     LOCATE 15 + X%, 1: PRINT "                                                                               "
     NEXT X%
     LOCATE 16, 15: INPUT "INPUT FOUR NEW VALUES (NUMBERS 1 TO 6)"; TMP1%, TMP2%, TMP3%, TMP4%
     IF TMP1% < 1 OR TMP1% > 6 THEN 9550
     IF TMP2% < 1 OR TMP2% > 6 THEN 9550
     IF TMP3% < 1 OR TMP3% > 6 THEN 9550
     IF TMP4% < 1 OR TMP4% > 6 THEN 9550
     GOTO 4390
9660 CLS
     PRTL$(1) = "YOU CAN PLOT  4  OF  10  PRESSURE VALUES vs. TIME"
     PRTL$(2) = "YOUR CHOICES ARE :"
     PRTL$(3) = " 1 - CHIM/HOUSE BUOYANCY"
     PRTL$(4) = " 2 - FLUE FRICTION LOSS"
     PRTL$(5) = " 3 - FIREBOX BUOYANCY"
     PRTL$(6) = " 4 - FIREBOX OUTLET LOSS"
     PRTL$(7) = " 5 - ENVELOPE LOSS"
     PRTL$(8) = " 6 - NET DRIVING PRESSURE"
     PRTL$(9) = " 7 - FIREBOX INLET LOSS"
     PRTL$(10) = " 8 - NET FIREBOX DRIVING PRESSURE"
     PRTL$(11) = " 9 - DILUTION PORT FRICTION LOSS"
     PRTL$(12) = "10 - WIND EFFECT"
     PRTL$(13) = "YOUR DEFAULT VALUES ARE > "
     PRTL$(14) = "PRESS <ENTER> TO SELECT DEFAULT VALUES"
     PRTL$(15) = "OR C TO ENTER FOUR NEW OUTPUT VALUES"
     LOCATE 2, 15: PRINT PRTL$(1)
     LOCATE 4, 15: PRINT PRTL$(2)
     FOR X% = 1 TO 10
     LOCATE 5 + X%, 20: PRINT PRTL$(X% + 2)
     NEXT X%
     LOCATE 17, 15: PRINT PRTL$(13); : PRINT USING " ##, ##, ##, and ##"; P1%, P2%, P3%, P4%
     FOR X% = 1 TO 2
     LOCATE 18 + X%, 15: PRINT PRTL$(13 + X%)
     NEXT X%
9900 LOCATE 22, 39: INPUT ANSP$
     IF ANSP$ = "" THEN P1% = 1: P2% = 2: P3% = 3: P4% = 4: GOTO 4390
     IF ANSP$ = "C" OR ANSP$ = "c" THEN 9940
     IF ANSP$ <> "c" OR ANSP$ <> "C" OR ANSP$ <> "" THEN 9900
9940 FOR X% = 1 TO 5
     LOCATE 17 + X%, 1: PRINT "                                                                               "
     NEXT X%
     LOCATE 18, 15: INPUT "INPUT FOUR NEW VALUES (NUMBERS 1 TO 10)"; P1%, P2%, P3%, P4%
     IF P1% < 1 OR P1% > 10 THEN 9940
     IF P2% < 1 OR P2% > 10 THEN 9940
      IF P3% < 1 OR P3% > 10 THEN 9940
      IF P4% < 1 OR P4% > 10 THEN 9940
      GOTO 4390
10030 CLS
      FLTL$(1) = "FOUR FLOW VALUES WILL BE PLOTTED vs. TIME"
      FLTL$(2) = "THE VALUES ARE :"
      FLTL$(3) = "1 - FURNACE FLOW (L/S)"
      FLTL$(4) = "2 - DILUTION FLOW (L/S)"
      FLTL$(5) = "3 - CHIMNEY FLOW (L/S)"
      FLTL$(6) = "4 - AIR FLOW DRAWN THROUGH THE ENVELOPE (L/S)"
      FLTL$(7) = "PRESS <ENTER> TO RETURN TO MAIN MENU"
      LOCATE 4, 20: PRINT FLTL$(1)
      LOCATE 6, 20: PRINT FLTL$(2)
      FOR X% = 1 TO 4
      LOCATE X% + 7, 20: PRINT FLTL$(X% + 2)
      NEXT X%
      LOCATE 15, 20: PRINT FLTL$(7)
      INPUT "", ZIP$
      GOTO 4390
      REM: PAUSE ROUTINE
      TTT = TIMER: WHILE TIMER < TTT + 3: WEND
      RETURN
10240 REM: SIMPLE QUESTION FORMAT   HDR$=TOP LINE,QN1$=FIRST QUESTION LINE
      REM: QN2$=SECOND DESCRIPTOR LINE OR LIMITS  TFLAG=1 FOR TEXT DEFAULT
10260 REM: DEFAULT VALUE IS IN EITHER FAULT(#) OR FAULT$(STRNG)
      REM: NEW INPUT VALUE IS STORED IN NFAULT(#) OR NFAULT$(STRNG)
      STRNG = 0
      IF TFLAG = 0 THEN GOTO 10470
      CLS : COLOR 7: PRINT HDR$: PRINT
      COLOR 15, 0: PRINT QN1$: COLOR 7: PRINT : PRINT QN2$: PRINT
      WHILE TFLAG
      PRINT "DEFAULT VALUE IS ";
      COLOR 15, 0: PRINT FAULT$
      LOCATE 23, 50: PRINT "HIT ENTER KEY TO USE DEFAULT": LOCATE 10, 10
      PRINT "INPUT YOUR SELECTION -> ";
      COLOR 0, 7: PRINT SPACE$(TLEN): LOCATE 10, 34: INPUT "", NFAULT$: COLOR 7, 0: PRINT
      IF NFAULT$ = "" THEN NFAULT$ = FAULT$: GOTO 10440
      LOCATE 22, 35: PRINT SPC(30); : LOCATE 15, 1
      PRINT "THE VALUE OF THIS ENTRY IS -> "; NFAULT$: PRINT
10410 INPUT "IS THE ENTRY CORRECT?  [Y]/N "; RESP$: IF RESP$ = "" OR RESP$ = "Y" OR RESP$ = "y" THEN GOTO 10440
      IF RESP$ = "N" OR RESP$ = "n" THEN GOTO 10260
      LOCATE 17, 1: GOTO 10410
10440 TFLAG = 0: STRNG = 1
      WEND
      IF STRNG = 1 THEN RETURN
10470 CLS : COLOR 7: PRINT HDR$: PRINT
      COLOR 15, 0: PRINT QN1$: COLOR 7: PRINT : PRINT QN2$: PRINT
      PRINT "DEFAULT VALUE IS ";
      COLOR 15, 0
      IF (INT(FAULT) - FAULT) = 0 THEN PRINT USING "##########"; FAULT: GOTO 10530
      COLOR 15, 0: PRINT USING "#####.#####"; FAULT
10530 LOCATE 23, 50: PRINT "HIT ENTER KEY TO USE DEFAULT": LOCATE 10, 10
      PRINT "INPUT YOUR SELECTION -> ";
      COLOR 15, 0: INPUT NFAULT$: COLOR 7: PRINT
      IF NFAULT$ = "" THEN NFAULT = FAULT: RETURN
      NFAULT = VAL(NFAULT$)
      LOCATE 22, 35: PRINT SPC(30); : LOCATE 15, 1
      PRINT USING "THE VALUE OF THIS ENTRY IS ->#####.#####"; NFAULT: PRINT
10600 INPUT "IS THE ENTRY CORRECT?  [Y]/N "; RESP$: IF RESP$ = "" OR RESP$ = "Y" OR RESP$ = "y" THEN RETURN
      IF RESP$ = "N" OR RESP$ = "n" THEN GOTO 10470
      LOCATE 17, 1: GOTO 10600
10690 PRINT "YOUR ENTRY IS QUESTIONABLE - PLEASE READ QUESTION AND TRY AGAIN. "
      T = TIMER: WHILE TIMER < T + 3: WEND: RETURN
      '    FLUE PIPE INPUT AIDS
      '
10715 CLS : PRINT "           YOUR FLUE PIPE SEGMENT DIMENSION IS NOT CONSISTENT": PRINT "             WITH PREVIOUSLY DEFINED OVERALL DIMENSIONS.": GOTO 10730
      CLS : PRINT "YOU HAVE USED ALL YOUR SECTION%S AND THE FLUE PIPE STILL DOES NOT FIT": PRINT "               PLEASE ENTER THE DATA FROM THE BEGINNING": GOTO 10730
10725 CLS : PRINT "       YOU HAVE FITTED THE FLUEPIPE TO THE CHIMNEY AND": PRINT "       YOU STILL HAVE SOME REMAINING SEGMENTS TO DEFINE"
10730 PRINT "PLEASE TRY AGAIN"
      PRINT "Press [ENTER] to continue...";
10835 KB$ = INKEY$: IF KB$ = "" THEN 10835
10840 RETURN
11000 '   ENVELOPE LEAK AND FRESH AIR INTAKE LOCATION
      CHM$(6) = "*"
      SCRTL$ = "VCLSCR"
      NF% = 4
      VAR(1) = LNPP
      VAR(2) = VCLINT
      VAR(3) = ARINT
      VAR(4) = NELINT
      GOSUB 2000
      LNPP = VAL(SI.DATA$(1))
      VCLINT = VAL(SI.DATA$(2))
      ARINT = VAL(SI.DATA$(3))
      NELINT = VAL(SI.DATA$(4))
      HDR$ = "DISTRIBUTION OF ENVELOPE LEAKS RELATIVE TO THE WIND DIRECTION"
11140 QN1$ = "ENTER THE SELECTION WHICH BEST DESCRIBES THE ORIENTATION OF ENVELOPE LEAKS": QN2$ = "(1. MAINLY WINDWARD  2. MAINLY LEEWARD  3. PARALLEL  4. UNIFORM  5. SHELTERED)": FAULT = LEAKDIST: GOSUB 10240: IF NFAULT < 1 OR NFAULT > 5 THEN GOSUB _
 10690: GOTO 11140
      LEAKDIST = NFAULT
      GOTO 5010
12000 '   FIREBOX FRESH AIR INTAKE
      CHM$(7) = "*"
      IF FB$ = "F" THEN SCRTL$ = "FPFAIR" ELSE SCRTL$ = "WSFAIR"
      NF% = 3
      VAR(1) = HINT
      VAR(2) = ARINTAKE
      VAR(3) = NELINTAK
      GOSUB 2000
      HINT = VAL(SI.DATA$(1))
      ARINTAKE = VAL(SI.DATA$(2))
      NELINTAK = VAL(SI.DATA$(3))
      IF ARINTAKE = 0 THEN INTAKE$ = "N" ELSE INTAKE$ = "Y": AR(15) = ARINTAKE: HT(15) = HINT
      GOTO 5010
      PRINT "                    PRESS ANY KEY TO CONTINUE"
      NFAULT$ = "N"
13020 KB$ = INKEY$: IF KB$ = "" THEN 13020 ELSE 13030
13030 RETURN
14000 REM   SET FLUEPIPE EQUAL TO CHIMNEY FOR FIREPLACE
      FPDI2(2) = CHDI2(2)
      FPDI2(3) = CHDI2(3)
      FPDI2(4) = CHDI2(4)
      FPELTL = CHELTL
      FPELTS = CHELTS
      FPELTO = CHELTO
      FPDENL = CHDENL
      FPDENS = CHDENS
      FPDENO = CHDENO
      FPHC(2) = CHHC(2)
      FPHC(3) = CHHC(3)
      FPHC(4) = CHHC(4)
      FPTHCL = CHTHCL
      FPTHCS = CHTHCS
      FPTHCO = CHTHCO
      RETURN
15000 REM    FLUE CAPS
      CHM$(8) = "*"
      SCRTL$ = "FLUCAP"
      NF% = 5
      VAR(1) = PHC
      VAR(2) = THETAW
      VAR(3) = PTC
      VAR(4) = VWINDT
      VAR(5) = FCAPL
      GOSUB 2000
      PHC = VAL(SI.DATA$(1))
      THETAW = VAL(SI.DATA$(2))
      PTC = VAL(SI.DATA$(3))
      VWINDT = VAL(SI.DATA$(4))
      FCAPL = VAL(SI.DATA$(5))
      VWINDH = VWINDT * COS(THETAW * 3.141593 / 180!)
      VWINDV = VWINDT * SIN(THETAW * 3.141593 / 180!)
      GOTO 5010
17000 CALL ReadSpcFile
      RETURN
17700 CALL CopySpcFile
17799 RETURN
18000 REM  FIREPLACE TYPES
      SCRTL$ = "FTYPES"
      NF% = 8
      FOR I% = 1 TO NF%: VAR(I%) = -1000: NEXT
      VA$(1) = FTYPE$
      VAR(2) = FBANGLE
      VA$(3) = GLASSDR$
      VAR(4) = BWL
      VAR(5) = SWL
      VAR(6) = FWL
      VAR(7) = BWH
      VAR(8) = HDRTHK
      GOSUB 2000
      FTYPE$ = SI.DATA$(1)
      FBANGLE = VAL(SI.DATA$(2))
      GLASSDR$ = SI.DATA$(3)
      BWL = VAL(SI.DATA$(4))
      SWL = VAL(SI.DATA$(5))
      FWL = VAL(SI.DATA$(6))
      BWH = VAL(SI.DATA$(7))
      HDRTHK = VAL(SI.DATA$(8))
      IF FTYPE$ = "M" OR FTYPE$ = "m" THEN FTYPE$ = "M": SCRTL$ = "FPL#1"
      IF FTYPE$ = "L" OR FTYPE$ = "l" THEN FTYPE$ = "L": SCRTL$ = "FPL#2"
      IF FTYPE$ = "F" OR FTYPE$ = "f" THEN FTYPE$ = "F": SCRTL$ = "FPL#3": GOTO 18500
      NF% = 12
      VAR(1) = ELEM(1)
      VAR(2) = ELEM(2)
      VAR(3) = ELEM(3)
      VAR(4) = WDENS(1)
      VAR(5) = WDENS(2)
      VAR(6) = WDENS(3)
      VAR(7) = CPW(1)
      VAR(8) = CPW(2)
      VAR(9) = CPW(3)
      VAR(10) = RVAL(1)
      VAR(11) = RVAL(2)
      VAR(12) = RVAL(3)
      GOSUB 2000
      ELEM(1) = VAL(SI.DATA$(1))
      ELEM(2) = VAL(SI.DATA$(2))
      ELEM(3) = VAL(SI.DATA$(3))
      WDENS(1) = VAL(SI.DATA$(4))
      WDENS(2) = VAL(SI.DATA$(5))
      WDENS(3) = VAL(SI.DATA$(6))
      CPW(1) = VAL(SI.DATA$(7))
      CPW(2) = VAL(SI.DATA$(8))
      CPW(3) = VAL(SI.DATA$(9))
      RVAL(1) = VAL(SI.DATA$(10))
      RVAL(2) = VAL(SI.DATA$(11))
      RVAL(3) = VAL(SI.DATA$(12))
      RETURN
18500 NF% = 17
      VA$(1) = AIRJK$
      VAR(2) = ELEM(1)
      VAR(3) = ELEM(2)
      VAR(4) = ELEM(3)
      VAR(5) = ELEM(4)
      VAR(6) = WDENS(1)
      VAR(7) = WDENS(2)
      VAR(8) = WDENS(3)
      VAR(9) = WDENS(4)
      VAR(10) = CPW(1)
      VAR(11) = CPW(2)
      VAR(12) = CPW(3)
      VAR(13) = CPW(4)
      VAR(14) = RVAL(1)
      VAR(15) = RVAL(2)
      VAR(16) = RVAL(3)
      VAR(17) = RVAL(4)
      GOSUB 2000
      AIRJK$ = SI.DATA$(1)
      ELEM(1) = VAL(SI.DATA$(2))
      ELEM(2) = VAL(SI.DATA$(3))
      ELEM(3) = VAL(SI.DATA$(4))
      ELEM(4) = VAL(SI.DATA$(5))
      WDENS(1) = VAL(SI.DATA$(6))
      WDENS(2) = VAL(SI.DATA$(7))
      WDENS(3) = VAL(SI.DATA$(8))
      WDENS(4) = VAL(SI.DATA$(9))
      CPW(1) = VAL(SI.DATA$(10))
      CPW(2) = VAL(SI.DATA$(11))
      CPW(3) = VAL(SI.DATA$(12))
      CPW(4) = VAL(SI.DATA$(13))
      RVAL(1) = VAL(SI.DATA$(14))
      RVAL(2) = VAL(SI.DATA$(15))
      RVAL(3) = VAL(SI.DATA$(16))
      RVAL(4) = VAL(SI.DATA$(17))
      RETURN
19000 REM WOODSTOVE PROPERTIES
      SCRTL$ = "WST#1"
      FTYPE$ = "W"
      FOR I% = 1 TO NF%: VAR(I%) = -1000: NEXT
      NF% = 13
      VAR(1) = WSTTAR
      VAR(2) = WSTSAR
      VAR(3) = WSTBAR
      VAR(4) = WSTFAR
      VA$(5) = WSTL$
      VAR(6) = ELEM(1)
      VAR(7) = ELEM(2)
      VAR(8) = WDENS(1)
      VAR(9) = WDENS(2)
      VAR(10) = CPW(1)
      VAR(11) = CPW(2)
      VAR(12) = RVAL(1)
      VAR(13) = RVAL(2)
      GOSUB 2000
      WSTTAR = VAL(SI.DATA$(1))
      WSTSAR = VAL(SI.DATA$(2))
      WSTBAR = VAL(SI.DATA$(3))
      WSTFAR = VAL(SI.DATA$(4))
      WSTL$ = SI.DATA$(5)
      ELEM(1) = VAL(SI.DATA$(6))
      ELEM(2) = VAL(SI.DATA$(7))
      WDENS(1) = VAL(SI.DATA$(8))
      WDENS(2) = VAL(SI.DATA$(9))
      CPW(1) = VAL(SI.DATA$(10))
      CPW(2) = VAL(SI.DATA$(11))
      RVAL(1) = VAL(SI.DATA$(12))
      RVAL(2) = VAL(SI.DATA$(13))
      RVAL(3) = VAL(SI.DATA$(12))
      RETURN
29000 REM *** USER ERROR HANDLING ROUTINES ***
      REM:  ERROR HANDLING ROUTINES
      COLOR 7
      IF ERR = 27 OR ERR = 24 THEN LOCATE 20, 40: PRINT "CHECK PRINTER": RESUME
      IF ERR = 61 THEN LOCATE 10, 40: PRINT "DISK IS FULL - USE ANOTHER DISKETTE": LOCATE 20, 1: PRINT SPACE$(79): PRINT SPACE$(79): RESUME 4750
      IF ERR = 53 AND ERL = 112 THEN GOTO 30000
      CLS : PRINT "PROBLEMS.... ERRORS DETECTED.  PROGRAM HALTED": PRINT USING "ERROR NUMBER ###; NEAREST LINE = ######"; ERR, ERL: STOP

30000 BEEP: CLS : LOCATE 5, 5: PRINT "In order to proceed, it is necessary that the file"
      LOCATE 7, 5: PRINT "'WINSTAL5.DAT' be in the current drive/directory."
      LOCATE 14, 5: PRINT "DO YOU WISH TO -"
      LOCATE 16, 1: PRINT "1. EXIT to DOS to copy 'WINSTAL5.DAT' to the current drive/directory"
      LOCATE 18, 1: PRINT "2. RUN the INSTALL program to create 'WINSTAL2.DAT'"
      LOCATE 20, 10: INPUT "Your choice  1 or 2"; A
      IF A = 2 THEN RUN "WINSTAL2" ELSE GOTO 600
30050 ' ASSIGN FIREBOX PROPERTIES
      IF FTYPE$ = "L" THEN GOTO 30110
      IF FTYPE$ = "F" THEN GOTO 30200
      IF FTYPE$ = "W" THEN GOTO 30300
      ' ASSIGN PROPERTIES OF WALLS OF MASONRY FIREPLACE
      ARWALL(1) = SWL * BWH: ARWALL(3) = ARWALL(1): ARWALL(2) = BWL * BWH: ARWALL(4) = SWL * (BWL + FWL) / 2: ARWALL(5) = FWL * BWH: ARWALL(6) = ARWALL(4)
      ELEMTHK(1) = ELEM(1) / 4: ELEMTHK(2) = ELEM(2) / 3: ELEMTHK(3) = ELEM(3) / 3
      FOR SURFACE% = 1 TO 6
      MASSWALL(SURFACE%, 1) = ARWALL(SURFACE%) * ELEMTHK(1) * WDENS(1): MASSWALL(SURFACE%, 2) = MASSWALL(SURFACE%, 1)
      MASSWALL(SURFACE%, 3) = MASSWALL(SURFACE%, 1): MASSWALL(SURFACE%, 4) = MASSWALL(SURFACE%, 1)
      MASSWALL(SURFACE%, 5) = ARWALL(SURFACE%) * ELEMTHK(2) * WDENS(2): MASSWALL(SURFACE%, 6) = MASSWALL(SURFACE%, 5): MASSWALL(SURFACE%, 7) = MASSWALL(SURFACE%, 5)
      MASSWALL(SURFACE%, 8) = ARWALL(SURFACE%) * ELEMTHK(3) * WDENS(3): MASSWALL(SURFACE%, 9) = MASSWALL(SURFACE%, 8): MASSWALL(SURFACE%, 10) = MASSWALL(SURFACE%, 8)
      CPWALL(SURFACE%, 1) = CPW(1): CPWALL(SURFACE%, 2) = CPW(1): CPWALL(SURFACE%, 3) = CPW(1): CPWALL(SURFACE%, 4) = CPW(1)
      CPWALL(SURFACE%, 5) = CPW(2): CPWALL(SURFACE%, 6) = CPW(2): CPWALL(SURFACE%, 7) = CPW(2): CPWALL(SURFACE%, 8) = CPW(3): CPWALL(SURFACE%, 9) = CPW(3): CPWALL(SURFACE%, 10) = CPW(3)
      RSI(SURFACE%, 1) = RVAL(1) * ELEMTHK(1): RSI(SURFACE%, 2) = RVAL(1) * ELEMTHK(1): RSI(SURFACE%, 3) = RVAL(1) * ELEMTHK(1):
      RSI(SURFACE%, 4) = RVAL(1) * ELEMTHK(1): RSI(SURFACE%, 5) = RVAL(2) * ELEMTHK(2): RSI(SURFACE%, 6) = RVAL(2) * ELEMTHK(2): RSI(SURFACE%, 7) = RVAL(2) * ELEMTHK(2)
      RSI(SURFACE%, 8) = RVAL(3) * ELEMTHK(3): RSI(SURFACE%, 9) = RVAL(3) * ELEMTHK(3): RSI(SURFACE%, 10) = RVAL(3) * ELEMTHK(3)
      NEXT SURFACE%
      IF GLASSDR$ = "Y" THEN MASSWALL(5, 1) = ARWALL(5) * GDTHK * GDDENS: CPWALL(5, 1) = GDCP
      'IF GLASSDR$="N" THEN MASSWALL(5,1)=VOLUME OF HOUSE
      FOR SECTION% = 1 TO 10: TWALL(5, SECTION%) = T9: NEXT SECTION%
      TWALL(1, 11) = T1: TWALL(2, 11) = T1: TWALL(3, 11) = T1: TWALL(4, 11) = T9: TWALL(5, 11) = T9: TWALL(6, 11) = T9: TSTACK = TN(17)
      'LPRINT
      RETURN
30110 'ASSIGN PROPERTIES OF WALL OF MASONRY WITH LINER
      ARWALL(1) = SWL * BWH: ARWALL(3) = ARWALL(1): ARWALL(2) = BWL * BWH: ARWALL(4) = SWL * (BWL + FWL) / 2: ARWALL(5) = FWL * BWH: ARWALL(6) = ARWALL(4)
      ELEMTHK(1) = ELEM(1): ELEMTHK(2) = ELEM(2) / 4: ELEMTHK(3) = ELEM(3) / 2: ELEMTHK(4) = ELEM(4) / 3
      FOR SURFACE% = 1 TO 6
      MASSWALL(SURFACE%, 1) = ARWALL(SURFACE%) * ELEMTHK(1) * WDENS(1): MASSWALL(SURFACE%, 2) = ARWALL(SURFACE%) * ELEMTHK(2) * WDENS(2)
      MASSWALL(SURFACE%, 3) = MASSWALL(SURFACE%, 2): MASSWALL(SURFACE%, 4) = MASSWALL(SURFACE%, 2): MASSWALL(SURFACE%, 5) = MASSWALL(SURFACE%, 2)
      MASSWALL(SURFACE%, 6) = ARWALL(SURFACE%) * ELEMTHK(3) * WDENS(2): MASSWALL(SURFACE%, 7) = MASSWALL(SURFACE%, 6)
      MASSWALL(SURFACE%, 8) = ARWALL(SURFACE%) * ELEMTHK(4) * WDENS(3): MASSWALL(SURFACE%, 9) = MASSWALL(SURFACE%, 8): MASSWALL(SURFACE%, 10) = MASSWALL(SURFACE%, 8)
      CPWALL(SURFACE%, 1) = CPW(1): CPWALL(SURFACE%, 2) = CPW(2): CPWALL(SURFACE%, 3) = CPW(2): CPWALL(SURFACE%, 4) = CPW(2): CPWALL(SURFACE%, 5) = CPW(2)
      CPWALL(SURFACE%, 6) = CPW(3): CPWALL(SURFACE%, 7) = CPW(3): CPWALL(SURFACE%, 8) = CPW(3): CPWALL(SURFACE%, 9) = CPW(3): CPWALL(SURFACE%, 10) = CPW(3)
      RSI(SURFACE%, 1) = ((RVAL(1) * ELEMTHK(1)) + .12): RSI(SURFACE%, 2) = RVAL(2) * ELEMTHK(2): RSI(SURFACE%, 3) = RVAL(2) * ELEMTHK(2): RSI(SURFACE%, 4) = RVAL(2) * ELEMTHK(2)
      RSI(SURFACE%, 5) = RVAL(2) * ELEMTHK(2): RSI(SURFACE%, 6) = RVAL(3) * ELEMTHK(3): RSI(SURFACE%, 7) = RVAL(3) * ELEMTHK(3)
      RSI(SURFACE%, 8) = RVAL(3) * ELEMTHK(3): RSI(SURFACE%, 9) = RVAL(3) * ELEMTHK(3): RSI(SURFACE%, 10) = RVAL(3) * ELEMTHK(3)
      NEXT SURFACE%
      IF GLASSDR$ = "Y" THEN MASSWALL(5, 1) = ARWALL(5) * GDTHK * GDDENS: CPWALL(5, 1) = GDCP
      'IF GLASSDR$="N" THEN MASSWALL(5,1)=VOLUME OF HOUSE
      FOR SECTION% = 1 TO 10: TWALL(5, SECTION%) = T9: NEXT SECTION%
      TWALL(1, 11) = T1: TWALL(2, 11) = T1: TWALL(3, 11) = T1: TWALL(4, 11) = T9: TWALL(5, 11) = T9: TWALL(6, 11) = T9: TSTACK = TN(17)
      RETURN
REM $INCLUDE: 'FACBUILT.BAS'
30300 'ASSIGN PROPERTIES OF WOODSTOVE
      ARWALL(1) = WSTSAR: ARWALL(3) = ARWALL(1): ARWALL(2) = WSTBAR: ARWALL(4) = WSTFAR: ARWALL(5) = ARWALL(2): ARWALL(6) = ARWALL(4)
      ELEMTHK(1) = ELEM(1) / 2: ELEMTHK(2) = ELEM(2) / 2: ELEMTHK(3) = .3: ELEMTHK(4) = .1 / 5
      FOR SURFACE% = 1 TO 6
      MASSWALL(SURFACE%, 1) = ARWALL(SURFACE%) * ELEMTHK(1) * WDENS(1): MASSWALL(SURFACE%, 2) = MASSWALL(SURFACE%, 1): MASSWALL(SURFACE%, 3) = ARWALL(SURFACE%) * ELEMTHK(2) * WDENS(2)
      MASSWALL(SURFACE%, 4) = MASSWALL(SURFACE%, 3): MASSWALL(SURFACE%, 5) = ARWALL(SURFACE%) * ELEMTHK(3) * 1.2:
      MASSWALL(SURFACE%, 6) = ARWALL(SURFACE%) * ELEMTHK(4) * 460: MASSWALL(SURFACE%, 7) = MASSWALL(SURFACE%, 6): MASSWALL(SURFACE%, 8) = MASSWALL(SURFACE%, 6)
      MASSWALL(SURFACE%, 9) = MASSWALL(SURFACE%, 6): MASSWALL(SURFACE%, 10) = MASSWALL(SURFACE%, 6)
      CPWALL(SURFACE%, 1) = CPW(1): CPWALL(SURFACE%, 2) = CPW(1): CPWALL(SURFACE%, 3) = CPW(2): CPWALL(SURFACE%, 4) = CPW(2): CPWALL(SURFACE%, 5) = 1005
      CPWALL(SURFACE%, 6) = 2400: CPWALL(SURFACE%, 7) = 2400: CPWALL(SURFACE%, 8) = 2400: CPWALL(SURFACE%, 9) = 2400: CPWALL(SURFACE%, 10) = 2400
      RSI(SURFACE%, 1) = RVAL(2) * ELEMTHK(2): RSI(SURFACE%, 2) = RVAL(2) * ELEMTHK(2): RSI(SURFACE%, 3) = RVAL(1) * ELEMTHK(1): RSI(SURFACE%, 4) = RVAL(1) * ELEMTHK(1): RSI(SURFACE%, 5) = .12
      RSI(SURFACE%, 6) = 8.7 * ELEMTHK(4): RSI(SURFACE%, 7) = RSI(1, 6): RSI(SURFACE%, 8) = RSI(1, 6): RSI(SURFACE%, 9) = RSI(1, 6): RSI(SURFACE%, 10) = RSI(1, 6)
      NEXT SURFACE%
      IF GLASSDR$ = "Y" THEN MASSWALL(5, 1) = ARWALL(5) * GDTHK * GDDENS: CPWALL(5, 1) = GDCP
      'IF GLASSDR$="N" THEN MASSWALL(5,1)=VOLUME OF HOUSE
      FOR SECTION% = 1 TO 10: TWALL(5, SECTION%) = T9: NEXT SECTION%
      TWALL(1, 11) = T1: TWALL(2, 11) = T1: TWALL(3, 11) = T1: TWALL(4, 11) = T9: TWALL(5, 11) = T9: TWALL(6, 11) = T9: TSTACK = TN(17)
      RETURN


